#include "console.h"

#include <stdarg.h>
#include <stdio.h>
#include <allegro.h>
#include <dpmi.h>
#include "map.h"
#include "global.h"

void InitMenu()
{
    int temploop;
    Selected = 1;		// sets the default selected text to 1

    text_mode(-1);
    screenbmp = load_bitmap("GFX\\bkgrnd.bmp", pallete);
    if (screenbmp == NULL)
       die ("Couldn't load GFX\\bkgrnd.bmp");
    set_pallete(pallete);
    blit(screenbmp, screen, 0, 0, 0, 0, 320, 200);
    tilebmp = load_bitmap("GFX\\maptiles.bmp", pallete);
    if (tilebmp == NULL)
       die ("Couldn't load GFX\\maptiles.bmp");
}

void CreateMenu(int x1, int y1, int rows, int columns, char bg[15])
{
    char *Errorcode; //temp variable to hold the error code

    oldscreenbmp = screenbmp;	// save the old screen to a file
    menubmp = load_bmp(bg, pallete);	// load the menu background
    if (menubmp == NULL)
       die ("Couldn't load BMP. Probably GFX\\console.bmp");
    blit(menubmp, screen, 0, 0, x1, y1, rows, columns);		// blit the background to the screen
    WriteMenuText(x1, y1, rows, columns);	// Calls the text writing function

}

void KillMenu()
{
    blit(oldscreenbmp, screen, 0, 0, 0, 0, 320, 200);	// restores the old screen
}

void DrawMenu()
{
    char *tempers;
    switch (GameStatus) {
    case MAP:
	InitMap();
	break;
    case MENU_MAIN:
	MenuEntry[0][0] = "Main Menu";
	MenuEntry[1][0] = "New Game   ";
	MenuEntry[2][0] = "Load Game  ";
	MenuEntry[3][0] = "Configure Players";
	MenuEntry[4][0] = "Introduction";
	MenuEntry[5][0] = "Exit Program";
	MenuLength = 5;
	CreateMenu(0, 0, 140, 60, "GFX\\console.bmp");
	break;
    case MENU_LOADGAME:
	MenuEntry[0][0] = "Load Game";
	MenuEntry[1][0] = "Saved Game 1";
	MenuEntry[2][0] = "Saved Game 2";
	MenuEntry[3][0] = "Saved Game 3";
	MenuEntry[4][0] = "Previous Menu";
	MenuLength = 4;
	CreateMenu(0, 0, 106, 50, "GFX\\console.bmp");
	break;
    case MENU_CONFIG_PLAYER:
	MenuEntry[0][0] = "Configure Players";
	MenuEntry[1][0] = "Party Name";
	MenuEntry[2][0] = "Character Names";
	MenuEntry[3][0] = "Status of Party";
	MenuEntry[4][0] = "Previous Menu";
	MenuLength = 4;
	CreateMenu(0, 0, 140, 50, "GFX\\console.bmp");
	break;
    case MENU_CONFIG_PLAYER_CHARNAMES:
	MenuEntry[0][0] = "Character Names";
	MenuEntry[1][0] = p1name;
	MenuEntry[2][0] = p2name;
	MenuEntry[3][0] = p3name;
	MenuEntry[4][0] = p4name;
	MenuEntry[5][0] = "Previous Menu";
	MenuLength = 5;
	CreateMenu(0, 0, 140, 60, "GFX\\console.bmp");
	break;
    }
}

void WriteMenuText()
{
    int TempLooper;

    textprintf(screen, font, 1, 1, 254, MenuEntry[0][0]);	// Prints out the menu title

    for (TempLooper = 1; TempLooper <= MenuLength; TempLooper++) {
	if (TempLooper == Selected)	// highlight the selected text
	 {
	    textprintf(screen, font, 1, (TempLooper * 10) + 1, 253, MenuEntry[TempLooper][0]);
	} else {
	    textprintf(screen, font, 1, (TempLooper * 10) + 1, 215, MenuEntry[TempLooper][0]);
	}
    }
//   blit(menubmp,screen,0,0,x1,y1,rows,columns);  //blit the text to the screen
}
